//+------------------------------------------------------------------+
//|                                               Ratio_Fractals.mq4 |
//| The Ratio code was written by 2007, Christof Risch (iya)         |
//| All credits to him                                               |
//| Linuxser 2007                                                    |
//| mladen   2008                                                    |
//+------------------------------------------------------------------+
#property copyright "Under The GNU General Public License V3"
#property link      "www.gnu.org"
#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Red  
#property indicator_color2 LimeGreen 
#property indicator_width1 2
#property indicator_width2 2

extern string  timeFrame           = "current time frame";
extern bool    Enable_Popup_Alerts = true;
extern bool    Enable_Sound        = true;
extern bool    Enable_Email_Alerts = false;

extern string note7            = "Arrow Type";
extern string note8            = "0=default,1=Thick,2=Thin,3=Hollow";
extern string note9            = "4=Round,5=Fractal,6=Diagonal Thin";
extern string note10           = "7=Diagonal Thick,8=Diagonal Hollow";
extern string note11           = "9=Thumb,10=Finger";
extern int    ArrowType        = 2;


//
//
//
//
//

double   Buffer1[];
double   Buffer2[];
int      TimeFrame;
datetime Prior_Time;
datetime last_hi_fractal, last_lo_fractal;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   string short_name;
   if (ArrowType == 0) {
   SetIndexBuffer(0, Buffer1);  SetIndexStyle(0,DRAW_ARROW); SetIndexArrow(0,119);
   SetIndexBuffer(1, Buffer2);  SetIndexStyle(1,DRAW_ARROW); SetIndexArrow(1,119);
   }
   if (ArrowType == 1) {
   SetIndexBuffer(0, Buffer1);  SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 234);
   SetIndexBuffer(1, Buffer2);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 233);
   }
   else if (ArrowType == 2) { 
   SetIndexBuffer(0, Buffer1);  SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 226);
   SetIndexBuffer(1, Buffer2);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 225);
   }
   else if (ArrowType == 3) { 
   SetIndexBuffer(0, Buffer1);  SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 242);
   SetIndexBuffer(1, Buffer2);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 241);
   }
   else if (ArrowType == 4) { 
   SetIndexBuffer(0, Buffer1);  SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 222);
   SetIndexBuffer(1, Buffer2);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 221);
   }
   else if (ArrowType == 5) { 
   SetIndexBuffer(0, Buffer1);  SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 218);
   SetIndexBuffer(1, Buffer2);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 217);
   }
   else if (ArrowType == 6) { 
   SetIndexBuffer(0, Buffer1);  SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 230);
   SetIndexBuffer(1, Buffer2);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 228);
   }
   else if (ArrowType == 7) { 
   SetIndexBuffer(0, Buffer1);  SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 238);
   SetIndexBuffer(1, Buffer2);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 236);
   }
   else if (ArrowType == 8) { 
   SetIndexBuffer(0, Buffer1);  SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 248);
   SetIndexBuffer(1, Buffer2);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 246);
   }
   else if (ArrowType == 9) { 
   SetIndexBuffer(0, Buffer1);  SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 68);
   SetIndexBuffer(1, Buffer2);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 67);
   }
   else if (ArrowType == 10) { 
   SetIndexBuffer(0, Buffer1);  SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0, 72);
   SetIndexBuffer(1, Buffer2);  SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1, 71);
   }

   SetIndexEmptyValue(0,0.0);
   SetIndexEmptyValue(1,0.0);
   SetIndexLabel(0,"Fractal Up");
   SetIndexLabel(1,"Fractal Down");

   //
   //
   //
   //
   //

   TimeFrame = stringToTimeFrame(timeFrame);
   
   string TimeFrameStr;
   switch(TimeFrame)
   {
      case PERIOD_M1:  TimeFrameStr="(M1)";      break;
      case PERIOD_M5:  TimeFrameStr="(M5)";      break;
      case PERIOD_M15: TimeFrameStr="(M15)";     break;
      case PERIOD_M30: TimeFrameStr="(M30)";     break;
      case PERIOD_H1:  TimeFrameStr="(H1)";      break;
      case PERIOD_H4:  TimeFrameStr="(H4)";      break;
      case PERIOD_D1:  TimeFrameStr="(Dayly)";   break;
      case PERIOD_W1:  TimeFrameStr="(Weekly)";  break;
      case PERIOD_MN1: TimeFrameStr="(Monthly)"; break;
      default :        TimeFrameStr="";
   }   
   IndicatorShortName("Ratio_Fractals("+short_name+")"+TimeFrameStr);
   return(0);
}
 
//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
           limit=Bars-counted_bars;
           if (TimeFrame > Period()) limit = MathMax(limit,TimeFrame/Period());

   //
   //
   //
   //
   //
   
	for(i = limit; i >= 0; i--)
	{
		int      shift1 = iBarShift(NULL,TimeFrame,Time[i]);
		datetime time1  = iTime    (NULL,TimeFrame,shift1);

      Buffer1[i]=iFractals(NULL,TimeFrame,MODE_UPPER,shift1);
      Buffer2[i]=iFractals(NULL,TimeFrame,MODE_LOWER,shift1);    

         //
         //
         //
         //
         //
         
         if(TimeFrame <= Period() || shift1==iBarShift(NULL,TimeFrame,Time[i-1])) continue;

         //
         //
	      //   apply interpolation
	      //
	      //
		 
  		   for(int n = 1; i+n < Bars && Time[i+n] >= time1; n++) continue;	

  		   double factor = 1.0 / n;
         for(int k = 1; k < n; k++)
		   {
			   Buffer1[i+k] = k*factor*Buffer1[i+n] + (1.0-k*factor)*Buffer1[i];
			   Buffer2[i+k] = k*factor*Buffer2[i+n] + (1.0-k*factor)*Buffer2[i];		
		   }
		   }  
         bool is_fractal = false;
         string alert_msg;
         double fractal_val = 0;
   
         // We look back a max of 3 closed bars and keep track of the last fractal time because the fractal doesn't always
         // occur on the most recently closed bar based on price action.   
     
        if (Buffer1[1] > 0 && Buffer1[1] != EMPTY_VALUE && iTime(Symbol(),TimeFrame,1) > last_hi_fractal) 
        {
        is_fractal = true;
        fractal_val = Buffer1[1];
        last_hi_fractal = iTime(Symbol(),TimeFrame,1);
        }
        else if (Buffer1[2] > 0 && Buffer1[2] != EMPTY_VALUE && iTime(Symbol(),TimeFrame,2) > last_hi_fractal) 
        {
        is_fractal = true;
        fractal_val = Buffer1[2];
        last_hi_fractal = iTime(Symbol(),TimeFrame,2);   
        } 
        else if (Buffer1[3] > 0 && Buffer1[3] != EMPTY_VALUE && iTime(Symbol(),TimeFrame,3) > last_hi_fractal) 
        {
        is_fractal = true;
        fractal_val = Buffer1[3];
        last_hi_fractal = iTime(Symbol(),TimeFrame,3);  
        }     
        if (is_fractal == true)
        {
        alert_msg = "A Fractal High of " + DoubleToStr(fractal_val,Digits) + " has occured on timeframe " + stringToTimeFrame(TimeFrame) + " for price bar closing @ " + TimeToStr(last_hi_fractal,TIME_DATE) + " " + TimeHour(last_hi_fractal) + ":" + TimeMinute(last_hi_fractal);   
        }
   
        if (is_fractal == false)
        { 
        if (Buffer2[1] > 0 && Buffer2[1] != EMPTY_VALUE && iTime(Symbol(),TimeFrame,1) > last_lo_fractal)
        {
        is_fractal = true;
        fractal_val = Buffer2[1];
        last_lo_fractal = iTime(Symbol(),TimeFrame,1);
        }
        else if (Buffer2[2] > 0 && Buffer2[2] != EMPTY_VALUE && iTime(Symbol(),TimeFrame,2) > last_lo_fractal) 
        {
        is_fractal = true;
        fractal_val = Buffer2[2];
        last_lo_fractal = iTime(Symbol(),TimeFrame,2);   
        } 
        else if (Buffer2[3] > 0 && Buffer2[3] != EMPTY_VALUE && iTime(Symbol(),TimeFrame,3) > last_lo_fractal) 
        {
        is_fractal = true;
        fractal_val = Buffer2[3];
        last_lo_fractal = iTime(Symbol(),TimeFrame,3);  
        }
        if (is_fractal == true)
        {
       alert_msg = "A Fractal Low of " + DoubleToStr(fractal_val,Digits) + " has occured on timeframe " + stringToTimeFrame(TimeFrame) + " for price bar closing @ " + TimeToStr(last_lo_fractal,TIME_DATE) + " " + TimeHour(last_lo_fractal) + ":" + TimeMinute(last_lo_fractal);   
       } 
       }       
   
       if (is_fractal == true)
       {
       if (Enable_Popup_Alerts == true)
       {
       Alert(Symbol()+":  "+ alert_msg);
       if (Enable_Sound == true)
       {
       PlaySound("alert2.wav");
       }
       } 
       if (Enable_Email_Alerts == true)
       {
       SendMail("Fractal Signal Alert",Symbol()+":  "+ alert_msg);
       }
     }
   return(0);
 }




//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   for(int l = StringLen(tfs)-1; l >= 0; l--)
   {
      int tchar = StringGetChar(tfs,l);
          if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
               tfs = StringSetChar(tfs, l, tchar - 32);
          else 
              if(tchar > -33 && tchar < 0)
                  tfs = StringSetChar(tfs, l, tchar + 224);
   }

   //
   //
   //
   //
   //
   
   int tf=0;
         if (tfs=="M1" || tfs=="1")     tf=PERIOD_M1;
         if (tfs=="M5" || tfs=="5")     tf=PERIOD_M5;
         if (tfs=="M15"|| tfs=="15")    tf=PERIOD_M15;
         if (tfs=="M30"|| tfs=="30")    tf=PERIOD_M30;
         if (tfs=="H1" || tfs=="60")    tf=PERIOD_H1;
         if (tfs=="H4" || tfs=="240")   tf=PERIOD_H4;
         if (tfs=="D1" || tfs=="1440")  tf=PERIOD_D1;
         if (tfs=="W1" || tfs=="10080") tf=PERIOD_W1;
         if (tfs=="MN" || tfs=="43200") tf=PERIOD_MN1;
   return(tf);
}